<template>
  <single-pane
    v-if="!$route.params.id"
    class="contracts-list"
  >
    <ob-table
      ref="obTable"
      :columns="columns"
      :show-add-button="false"
      :functional-panel="true"
      :remote-opt="{
        method: api.contract.getContractsList,
        arguments: {
          ...listRequestParams()
        }
      }"
      sort-init="created_at:desc:datetime"
      :is-fixed-header="true"
      data-qa="contractsDraftList"
      @add="onAddContract"
      @select="onSelectionItem"
    >
      <template slot="noneContent">
        <not-info @createNewContract="createNewContract"/>
      </template>

      <template v-slot:number="{ data }">
        <div class="w-110">
          <template v-if="data.item.isChild">
            <div class="d-f jc-fe">
              <img src="./img/nested.svg" />
            </div>
          </template>
          <template v-else-if="!data.item.isTariffAgreement">
            <div class="contract-number">
              <ObTooltip
                position="bottom-start"
                :content="`Договор создан ${data.item.is_manual_created ? 'вручную' : 'автоматически'}`"
              >
                <i
                  class="icon"
                  :class="data.item.is_manual_created ? 'hand' : 'digital-document'"
                />
              </ObTooltip>
              <span>{{ data.item.number }}</span>
            </div>
          </template>
        </div>
      </template>
      <template v-slot:tariffAgreementNumber="{ data }">
        <div class="w-110">
          <template v-if="data.item.isTariffAgreement">
            <div class="contract-number">
              <ObTooltip
                position="bottom-start"
                :content="`Договор создан ${data.item.is_manual_created ? 'вручную' : 'автоматически'}`"
              >
                <i
                  class="icon"
                  :class="data.item.is_manual_created ? 'hand' : 'digital-document'"
                />
              </ObTooltip>
              <span>{{ data.item.number }}</span>
            </div>
          </template>
        </div>
      </template>
      <template v-slot:customerTitle="{ data }">
        <div class="contracts-list__icons">
          <i
            class="icon"
            :class="data.item.client_title ? 'role-client' : ''"
          />
          <span>{{data.item.client_title}}</span>
        </div>
      </template>
      <template v-slot:original_number="{ data }">
        <div
          :title="data.item.original_number"
          class="original-number"
        >
          {{data.item.original_number}}
        </div>
      </template>
      <template v-slot:performer="{ data }">
        <div class="contracts-list__icons">
          <i
              class="icon"
              :class="data.item.doer_title ? data.item.doer_title === companyName ? 'role-domain-owner' : 'truck-sm' : ''"
          />
          <span>{{data.item.doer_title}}</span>
        </div>
      </template>
<!--      <template v-slot:extraFuncToPanel>-->
<!--        <div class="contracts-list__select">-->
<!--          <div class="contracts-list__select-inline">-->
<!--            <span>Тип договора: </span>-->
<!--            <ob-inline-select-->
<!--                    v-model="typeContract.uuid"-->
<!--                    :items="typeContractItems"-->
<!--            />-->
<!--          </div>-->
<!--          <div class="contracts-list__select-inline">-->
<!--            <span>Заказчик: </span>-->
<!--            <ob-inline-select-->
<!--                    v-model="customer.uuid"-->
<!--                    :items="customers"-->
<!--            />-->
<!--          </div>-->
<!--          <div class="contracts-list__select-inline">-->
<!--            <span>Исполнитель: </span>-->
<!--            <ob-inline-select-->
<!--                    v-model="performer.uuid"-->
<!--                    :items="performers"-->
<!--            />-->
<!--          </div>-->
<!--        </div>-->
<!--      </template>-->

      <div slot="dropdownMenu" slot-scope="{ data }">
        <ob-menu-dropdown
          :items="getDropdownItems(data)"
        />
      </div>
    </ob-table>
<!--    <Chat/>-->
    <delete-modal
      ref="deleteModal"
      @on-delete="deleteContractDraft"
    />
  </single-pane>
</template>

<script>
import api from '@/api'
import notInfo from './noInfoIntoDraft'
import ObTable from 'common-components/src/obComponents/obTable'
import SinglePane from 'common-components/src/obComponents/obSinglePanels'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
import ObTooltip from "common-components/src/obComponents/obTooltip"
import moment from 'moment'
import DeleteModal from '@/components/Contract/detail/modals/DeleteContractDraftModal'
// import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect'
// import Chat from '@/components/chat'
import { mapGetters } from 'vuex'

export default {
  name: 'ContractsDraft',
  components: {
    notInfo,
    ObTable,
    SinglePane,
    ObMenuDropdown,
    DeleteModal,
    ObTooltip,
    // ObInlineSelect
    // Chat
  },
  data () {
    return {
      api,
      processData: null,
      typeContract: {
        title: 'Все',
        uuid: '1'
      },
      typeContractItems: [
        {
          title: 'Все',
          uuid: '1'
        },
        {
          title: 'Перевозки',
          uuid: '2'
        }
      ],
      performer: {
        title: 'Все',
        uuid: '1'
      },
      performers: [
        {
          title: 'Все',
          uuid: '1'
        },
        {
          title: 'ООО "ЛЕРУА МЕРЛЕН ВОСТОК"',
          uuid: '2'
        }
      ],
      customer: {
        title: 'Все',
        uuid: '1'
      },
      customers: [
        {
          title: 'Все',
          uuid: '1'
        },
        {
          title: 'ООО "ОБОЗ ДИДЖИТАЛ"',
          uuid: '2'
        }
      ],
      createContract: ''
    }
  },
  computed: {
    ...mapGetters({
      companyName: 'user/companyName',
      isModerator: 'user/isModerator'
    }),
    columns () {
      return [
        {
          title: '№ договора',
          slotName: 'number',
          exactWidth: '160px'
        },
        {
          title: '№ тарифного соглашения',
          slotName: 'tariffAgreementNumber',
          exactWidth: '160px'
        },
        {
          title: 'Тип договора',
          key: 'contract_type_title'
        },
        {
          title: 'заказчик',
          key: 'client_title',
          slotName: 'customerTitle'
        },
        {
          title: 'Исполнитель',
          key: 'doer_title',
          slotName: 'performer'
        },
        {
          title: 'Внешний № договора',
          key: 'original_number',
          slotName: 'original_number',
          exactWidth: '100px'
        },
        {
          title: 'Создан',
          key: 'created_at',
          html: ({ created_at }) => this.getHtmlDatetime(created_at),
          isAlignRight: true
        },
        {
          title: 'действует с',
          key: 'from_date',
          html: ({ from_date }) => this.getHtmlDatetime(from_date, false),
          isAlignRight: true
        },
        {
          title: 'действует по',
          key: 'to_date',
          html: ({ to_date, isTimeless, is_timeless }) => this.getHtmlToDate(to_date, isTimeless || is_timeless),
          isAlignRight: true
        },
        {
          title: ' ',
          slotName: 'dropdownMenu',
          exactWidth: '60',
          action: true
        }
      ]
    }
  },
  async created () {
    await this.checkRoute()
  },
  watch: {
    async $route() {
      await this.checkRoute()
    }
  },
  methods: {
    async createNewContract(uuid) {
      this.createContract = uuid;
      this.onAddContract();
    },
    async checkRoute () {
      if (this.$route.params.id) {
        await this.onAddContract({ replace: true })
      }
    },
    async onAddContract ({ replace = false } = {}) {
      const notificationId = `${new Date().getTime()}save`;
      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        });
        let contractCode = this.$route.params.id || this.createContract || ''
        if (!['tracking', 'transportation_parent_contract'].includes(contractCode)) {
          contractCode = this.isModerator ? 'tracking' : 'transportation_parent_contract'
        }
        const types = await api.contract.getContractTypes()
        const contractTypeUuid = types.content.find(item => item.contractTypeCode.toLowerCase() === contractCode).uuid
        const data = await api.contract.createContract({ contractTypeUuid })
        localStorage.setItem(`contract-${data.uuid}`, JSON.stringify(data))
        this.$router[replace ? 'replace' : 'push']({ name: 'contracts__detail', params: { id: data.uuid } })
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      } finally {
        this.$notification({event: 'close', id: notificationId})
      }
    },
    getHtmlDatetime(datetime, isTime = true) {
      return datetime ? `
        <div class="field-datetime">
          <div>${moment(datetime).locale('ru').format('L')}</div>
          <div class="field-time ${isTime ? '' : 'hidden'}">${moment(datetime).locale('ru').format('LT')}</div>
        </div>
      ` : ''
    },
    getHtmlToDate (datetime, isTimeless = false) {
      if (isTimeless) return 'Бессрочно';

      return this.getHtmlDatetime(datetime, false)
    },
    getDropdownItems (data) {
      return [
        {
          title: 'Удалить черновик',
          className: 'menu-button-danger',
          method: () => this.deleteItem(data.item)
        }
      ]
    },
    async deleteItem (data) {
      this.processData = data;
      this.$refs.deleteModal.open()
    },
    async deleteContractDraft () {
      this.$refs.deleteModal.close();
      const notificationId = `${new Date().getTime()}remove`;
      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Удаление',
          id: notificationId
        });
        await api.contract.deleteContractDraft({ uuid: this.processData.uuid });
        setTimeout(() => {
          this.$refs.obTable.loadData()
        }, 500);
        this.$notification({
          type: 'system_notification_success',
          message: 'Удалено'
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалено'
        })
      } finally {
        this.$notification({event: 'close', id: notificationId})
      }
    },
    onSelectionItem (data) {
      this.$router.push({ name: 'contracts__detail', params: { id: data.uuid } })
    },
    listRequestParams () {
      return {
        status: 'DRAFT'
      }
    }
  }
}
</script>

<style lang="scss">
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.contracts-list {
  .field-datetime {
    @include font-mixin(14px, 20px, 400);
    text-align: right;
    .field-time {
      color: $color-grey-span;
      &.hidden {
        display: none;
      }
    }
  }
  .menu-button-danger {
    button {
      color: $color-error;
    }
  }

  .w-110 {
    width: 110px!important;
  }

  .ob-table-inner {
    .ob-menu-dropdown-container:not(.--opened) {
      opacity: 0;
      pointer-events: none;
    }
    tr:hover {
      .ob-menu-dropdown-container {
        opacity: 1;
        pointer-events: all;
      }
    }
  }

  .table-panel-inner {
    display: flex;
    flex-direction: column;
    .menu-dropdown {
      min-width: auto!important;
    }
  }
  &__icons {
    display: flex;
    align-items: center;

    i {
      padding-right: 13px;
      color: $blue-700;
    }
  }
  &__select {
    display: flex;
    align-items: center;
    width: 100%;
    &-inline {
      background: $blue-blue-hoarfrost;
      border-radius: 19px;
      padding: 5px 9px;
      font-size: 14px;
      line-height: 18px;
      letter-spacing: 0.2px;
      color: $color-grey-span;

      &:nth-child(1) {
        margin-right: 12px;
      }

      &:nth-child(2) {
        margin-right: 22px;
      }
    }
  }
}
</style>
<style lang="scss" scoped>
::v-deep .ob-func-panel{
  &__controls{
    justify-content: flex-start;
    &-side{
      &:first-child{
        .ob-func-panel__control{
          &:nth-child(1){
            display: none;
          }
          &:nth-child(2){
            display: none;
          }
        }
      }
      &:last-child{
        width: 100%;
        .ob-func-panel__control{
          &:first-child{
            width: 100%;
          }
        }
      }
    }
  }
}

.contract-number {
  display: flex;
  align-items: center;
  white-space: nowrap;
  .icon {
    margin-right: 12px;
    font-size: 14px;
    color: $color-blue-navy-blue;
  }
}

.original-number {
  max-width: 100px;
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}
</style>
